// CreditServiceBean.java

package creditService.ejb;

//import java.util.*;
import java.rmi.*;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.*;

import oracle.aurora.jem.*;

//////////////////////////////////////////////////////////////////////  
public class CreditServiceBean implements SessionBean
{
    SessionContext ctx;
    final static String creditorBeanName = "java:comp/env/ejb/Creditor";

    //////////////////////////////////////////////////////////////////////  
    public String checkCRED(String  clientName, String creditCardNumber,
                            float amount)
      throws RemoteException, TestException
    {
    	System.out.println("=======>CreditServiceBean: checkCRED: begin");
      System.out.println("         : clientName = " + clientName);
      System.out.println("         : creditCardNumber = " + creditCardNumber);
      System.out.println("         : amount = " + amount);

    	String creditCheck = "CREDIT FAILED";

      try
      {
        // 1. get a JNDI context
        Context context = new InitialContext();

        // for every itemName in itemNames
        CreditorHome creditorHome =
          (CreditorHome)context.lookup(creditorBeanName);
        CreditorRemote creditorRemote = 
          (CreditorRemote)creditorHome.findByPrimaryKey(creditCardNumber);

        System.out.println("         : CreditorRemote found");
        String creditorName = creditorRemote.getCreditorName();
        System.out.println("         : creditorName = " + creditorName);
        float availableCredit = creditorRemote.getAvailableCredit().floatValue();
  	    System.out.println("         : availableCredit = " + availableCredit);

        if(!creditorName.equals(clientName))
          creditCheck = "Invalid Creditor Name";
        else if(amount <= availableCredit)
        {
          availableCredit -= amount;
        	creditCheck = "CREDIT APPROVED";
        	creditorRemote.setAvailableCredit(new Float(availableCredit));
  	    }
      }
    	catch(NamingException ne)
    	{
    	    System.out.println("         : NamingException: could not find " +
                             creditorBeanName);
    	    throw new TestException("Could Not Obtain the Context");
    	}
    	catch(FinderException fe)
    	{
    	    System.out.println("         : FinderException: setting " +
                             "creditCheck = Invalid Credit Card");
          creditCheck = "Invalid Credit Card";
    	}
    	finally
    	{
    	    System.out.println("=======>CreditServiceBean: checkCRED: " +
                             "end--returning  " + creditCheck);
          return creditCheck;
    	}
    }

    //////////////////////////////////////////////////////////////////////  
    //**************** ALL SessionBean specific APIs *******************//
    public void setSessionContext(SessionContext ctx)
    {
      this.ctx = ctx;
    }
    //////////////////////////////////////////////////////////////////////  
    public void ejbCreate() throws RemoteException, CreateException 
    {
      System.out.println("=======>CreditServiceBean: ejbCreate: begin/end");
    }
    //////////////////////////////////////////////////////////////////////  
    public void ejbActivate() {}
    public void ejbPassivate() {}
    public void ejbRemove() {}
}
