// CreditorBean.java

package creditService.ejb;

import java.rmi.*;
import javax.ejb.*;
import java.sql.Date;

//////////////////////////////////////////////////////////////////////  
public abstract class CreditorBean implements EntityBean
{
    EntityContext ctx;

    // getter remote methods
    public  abstract  String  getCreditorName()    ;
    public  abstract  String  getCreditCardNumber();
    public  abstract  Float   getAvailableCredit() ;
    public  abstract  Date    getExpiryDate()      ;

    // setter remote methods
    public  abstract  void  setCreditorName(String name)           ;
    public  abstract  void  setCreditCardNumber(String credCardnum);
    public  abstract  void  setAvailableCredit(Float  availCred)   ;
    public  abstract  void  setExpiryDate(Date   date)             ;

    //////////////////////////////////////////////////////////////////////  
    // **************** ALL Entity Bean specific APIs ******************* //
    public String ejbCreate(String creditorName, String creditCardNumber, 
                            Date expiryDate)
      throws CreateException
    {
    	setCreditorName(creditorName);
    	setCreditCardNumber(creditCardNumber);
    	setExpiryDate(expiryDate);
    	setAvailableCredit(new Float(5000.00));
    	return creditCardNumber;
    }

    public void ejbPostCreate(String creditorName, String creditCardNumber,
                              Date expiryDate)
      throws CreateException
    {  // called when just after bean created
    }

    public void ejbPostCreate(Integer empNo) throws CreateException
    {  // called when just after bean created
    }

    public void ejbStore()
    {  // called when bean persisted
    }

    public void ejbLoad()
    {   // called when bean loaded
    }

    public void ejbRemove()
    { // called when bean removed
    }

    public void ejbActivate()
    { // called when bean activated
    }

    public void ejbPassivate()
    { // called when bean deactivated
    }

    public void setEntityContext(EntityContext ctx)
    {
      this.ctx = ctx;
    }

    public void unsetEntityContext()
    {
      this.ctx = null;
    }

    public EJBLocalHome getEJBLocalHome()
    {
      return ctx.getEJBLocalHome();
    }

    public Object getPrimaryKey()
    {
      return ctx.getEJBLocalObject().getPrimaryKey();
    }

    public boolean isIdentical(EJBLocalObject remote)
    {
      return ctx.getEJBLocalObject().isIdentical(remote);
    }

    public void remove() throws RemoveException
    {
      ctx.getEJBLocalObject().remove();
    }
}


