// InventoryServiceBean.java

package inventoryService.ejb;

//import java.util.*;
import java.rmi.*;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.*;

import oracle.aurora.jem.*;

//////////////////////////////////////////////////////////////////////  
public class InventoryServiceBean implements SessionBean
{
    SessionContext ctx;
    final static String productBeanName = "java:comp/env/ejb/Product";

    //////////////////////////////////////////////////////////////////////  
    public boolean[] checkINV(String[] productNames, int[] quantities)
    	throws RemoteException, TestException
    {
      System.out.println("=======>InventoryServiceBean: checkINV: begin");
      for(int i=0; productNames.length > 0 && i < productNames.length; i++)
        System.out.println("         : (product, quantity) = " + 
                           productNames[i] + ", " + quantities[i]);

    	if(productNames == null || quantities == null)
        throw new TestException("productNames OR quantities cannot be NULL");
      if(productNames.length != quantities.length)
        throw new TestException(
                          "productNames.length MUST equal quantities.length");
    	if(productNames.length <= 0)
        throw new TestException("productNames.length cannot be Zero");

    	boolean[] invCheck = new boolean[productNames.length];
      try
      {
        ProductHome productHome = null;
        for(int i=0; i < productNames.length; i++)
        {
          try
          {
            if(i == 0)
            {
              // 1. get a JNDI context
            	Context context = new InitialContext();

        			// 2. lookup the productHome
            	productHome = (ProductHome) context.lookup(productBeanName);
            }

      		    // 3. find the remote-inteface for the productHome
              ProductRemote productRemote =
                  productHome.findByPrimaryKey(productNames[i].toUpperCase());

    		    int availableUnits = productRemote.getAvailableUnits().intValue();
            System.out.println("         : BEFORE: availableUnits["+i+"] = " + 
                               availableUnits);
    		    if(availableUnits >= quantities[i])
            {
              availableUnits -= quantities[i];
            	invCheck[i] = true;
            	productRemote.setAvailableUnits(new Integer(availableUnits));
              System.out.println("         : AFTER: availableUnits["+i +"] = " +
                                 availableUnits);
            }
            else
              invCheck[i] = false;
          }
          catch (FinderException fe)
          {
            System.out.println("         : FinderException found");
            invCheck[i] = false;
          }
        }
      }
      catch (NamingException ne)
      {
  	    throw  new TestException("Could Not Obtain the Context");
      }
      finally
      {
        System.out.println("         : Returning: ");
        for(int i=0; invCheck != null && i < invCheck.length; i++)
    		System.out.println("         : invCheck["+i+"]=" + invCheck[i]);
        System.out.println("=======>InventoryServiceBean: checkINV: end");
        return invCheck;
      }
    }

    //////////////////////////////////////////////////////////////////////  
    public void setSessionContext(SessionContext ctx)
    {
      this.ctx = ctx;
    }
    //////////////////////////////////////////////////////////////////////  
    public void ejbCreate() throws RemoteException, CreateException 
    {
      System.out.println("=======>InventoryServiceBean: ejbCreate: begin/end");
    }
    //////////////////////////////////////////////////////////////////////  
    public void ejbActivate() {}
    public void ejbPassivate() {}
    public void ejbRemove() {}
}


