// ProductBean.java

package inventoryService.ejb;

import java.util.*;
import java.rmi.*;
import javax.ejb.*;
import javax.rmi.*;

//////////////////////////////////////////////////////////////////////  
public abstract class ProductBean implements EntityBean
{
    EntityContext ctx;

    // Get Methods
    public  abstract String   getProductName();
    public  abstract Integer  getProductNumber();
    public  abstract Integer  getAvailableUnits();
    public  abstract Float    getUnitPrice();
    public  abstract String   getDescription();

    // Set Methods
    public  abstract void  setProductName(String name);
    public  abstract void  setProductNumber(Integer number);
    public  abstract void  setAvailableUnits(Integer availUnits);
    public  abstract void  setUnitPrice(Float price);
    public  abstract void  setDescription(String desc);

    //////////////////////////////////////////////////////////////////////  
    public boolean isAvailable() 
    {
    	Integer av_units = getAvailableUnits();
      if(getAvailableUnits() == null)
        return false;
    	else
        return getAvailableUnits().intValue() > 0;
    }

    //////////////////////////////////////////////////////////////////////  
    //**************** ALL Entity Bean specific APIs *******************//
    public String ejbCreate(String productName, Integer productNumber,
                            Integer availableUnits, Float unitPrice)
      throws CreateException
    {
    	setProductName(productName);
    	setProductNumber(productNumber);
    	setAvailableUnits(availableUnits);
    	setUnitPrice(unitPrice);
    	setDescription("New product description....");
    	return null;
    }

    public void ejbPostCreate(String productName, Integer productNumber,
                              Integer availableUnits, Float unitPrice)
      throws CreateException
    {  // called just after bean created
    }

    public void ejbPostCreate(String productName) throws CreateException
    {  // called just after bean created
    }

    public void ejbStore()
    {  // called when bean persisted
    }

    public void ejbLoad()
    {   // called when bean loaded
    }

    public void ejbRemove()
    { // called when bean removed
    }

    public void ejbActivate()
    { // called when bean activated
    }

    public void ejbPassivate()
    { // called when bean deactivated
    }

    public void setEntityContext(EntityContext ctx)
    {
    	ctx = ctx;
    }

    public void unsetEntityContext()
    {
    	ctx = null;
    }

    public EJBLocalHome getEJBLocalHome()
    {
    	return ctx.getEJBLocalHome();
    }

    public Object getPrimaryKey()
    {
    	return ctx.getEJBLocalObject().getPrimaryKey();
    }

    public boolean isIdentical(EJBLocalObject remote)
    {
      return ctx.getEJBLocalObject().isIdentical(remote);
    }

    public void remove() throws RemoveException
    {
    	ctx.getEJBLocalObject().remove();
    }
}
