// LineItemBean.java

package purchaseOrderService.ejb;

import java.util.*;
import java.rmi.*;
import javax.ejb.*;
import javax.rmi.*;

//////////////////////////////////////////////////////////////////////  
public abstract class LineItemBean implements EntityBean
{
    EntityContext ctx;

    // Get Methods
    public abstract  String   getLineItemName();
    public abstract  Integer  getOrderedQuantity();
    public abstract  Integer  getShippedQuantity();
    public abstract  PurchaseOrderRemote  getPurchaseOrder();

    // Set Methods
    public abstract  void  setLineItemName(String liName);
    public abstract  void  setOrderedQuantity(Integer orderedQnty);
    public abstract  void  setShippedQuantity(Integer shippedQnty);
    public abstract  void  setPurchaseOrder(PurchaseOrderRemote po);

    //////////////////////////////////////////////////////////////////////
    //**************** ALL Entity Bean specific APIs *******************//
    public Object ejbCreate(String lineItemName, int quantity)
    	throws CreateException
    {
      System.out.println("=======>LineItemBean: ejbCreate:  lineItemName = " + 
                         lineItemName + "  quantity = " + quantity);

    	setLineItemName(lineItemName);
      setOrderedQuantity(new Integer(quantity));
      setShippedQuantity(new Integer(0));
    	return null;
    }

    public void ejbPostCreate(String lineItemName, int quantity)
      throws CreateException 
    {  // called just after bean created
    }

    public void ejbStore()
    {  // called when bean persisted
    }

    public void ejbLoad()
    {   // called when bean loaded
    }

    public void ejbRemove()
    { // called when bean removed
    }

    public void ejbActivate()
    { // called when bean activated
    }

    public void ejbPassivate()
    { // called when bean deactivated
    }

    public void setEntityContext(EntityContext ctx)
    {
    	ctx = ctx;
    }

    public void unsetEntityContext()
    {
    	ctx = null;
    }

    public EJBLocalHome getEJBLocalHome()
    {
    	return ctx.getEJBLocalHome();
    }

    public Object getPrimaryKey()
    {
    	return ctx.getEJBLocalObject().getPrimaryKey();
    }

    public boolean isIdentical(EJBLocalObject remote)
    {
      return ctx.getEJBLocalObject().isIdentical(remote);
    }

    public void remove() throws RemoveException
    {
    	ctx.getEJBLocalObject().remove();
    }
}
