// PurchaseOrderServiceRemote.java

package purchaseOrderService.ejb;

import javax.ejb.*;
import java.rmi.*;

public interface PurchaseOrderServiceRemote extends EJBObject
{
    // takeOrder--returns a PO_Number--invoked through AC4J call from client
    public int takeOrder(String clientName, String creditCardNumber,
                         String[] itemName, int[] quantity)
	throws RemoteException, TestException;

    // getStatus --returns status={ NEWPO, CHECKINV, CHECKCREDIT, CHECKINVCRED, 
    //                           CANCELLED, CANCELLED_NOCREDIT, CANCELLED_NOINV,
    //                           INPROCESS, PROCESSED, SHIPPED }
    public String getStatus(int poNumber)
      throws RemoteException, TestException;

    // invoked by takeOrder through AC4J call
    public void  processOrder(int poNumber, String[] itemName, int[] quantity)
      throws RemoteException, TestException;

    // invoked by AC4J reaction registerd in startProcessingPO
    public void  processOrderCallback(boolean[] invInfo, String credInfo)
      throws RemoteException, TestException;
}
