// Status.java

package purchaseOrderService.ejb;

public class Status
{
  public final static int STATUS_BASESTATUS           = 200;
  public final static int STATUS_INVALID              = STATUS_BASESTATUS;
  public final static int STATUS_NEWPO                = STATUS_BASESTATUS + 1;
  public final static int STATUS_VALID_CREDIT         = STATUS_BASESTATUS + 2;
  public final static int STATUS_VALID_INVENTORY      = STATUS_BASESTATUS + 3;
  public final static int STATUS_INVALID_CREDIT_CARD  = STATUS_BASESTATUS + 4;
  public final static int STATUS_CANCELLED_NOCREDIT   = STATUS_BASESTATUS + 5;
  public final static int STATUS_CANCELLED_NOINV      = STATUS_BASESTATUS + 6;
  public final static int STATUS_INPROCESS            = STATUS_BASESTATUS + 7;
  public final static int STATUS_PROCESSED            = STATUS_BASESTATUS + 8;
  public final static int STATUS_SHIPPED              = STATUS_BASESTATUS + 9;
  public final static int STATUS_MAX                  = STATUS_SHIPPED;

  public static String getString(int status)
  {
    if(status < Status.STATUS_BASESTATUS || status > Status.STATUS_MAX || 
       status == Status.STATUS_INVALID)
      return "STATUS_INVALID";

    if(status == Status.STATUS_NEWPO)
      return "STATUS_NEWPO";
    else if(status == Status.STATUS_VALID_CREDIT)
      return "STATUS_VALID_CREDIT";
    else if(status == Status.STATUS_VALID_INVENTORY)
      return "STATUS_VALID_INVENTORY";
    else if(status == Status.STATUS_INVALID_CREDIT_CARD)
      return "STATUS_INVALID_CREDIT_CARD";
    else if(status == Status.STATUS_CANCELLED_NOCREDIT)
      return "STATUS_CANCELLED_NOCREDIT";
    else if(status == Status.STATUS_CANCELLED_NOINV)
      return "STATUS_CANCELLED_NOINV";
    else if(status == Status.STATUS_INPROCESS)
      return "STATUS_INPROCESS";
    else if(status == Status.STATUS_PROCESSED)
      return "STATUS_PROCESSED";
    else if(status == Status.STATUS_SHIPPED)
      return "STATUS_SHIPPED";
    else
      return "STATUS_INVALID";
  }

  public static int getStatus(String status)
  {
    if(status == null || status.equals("STATUS_INVALID"))
      return Status.STATUS_INVALID;

    if(status.equals("STATUS_NEWPO"))
      return Status.STATUS_NEWPO;
    else if(status.equals("STATUS_VALID_CREDIT"))
      return Status.STATUS_VALID_CREDIT;
    else if(status.equals("STATUS_VALID_INVENTORY"))
      return Status.STATUS_VALID_INVENTORY;
    else if(status.equals("STATUS_INVALID_CREDIT_CARD"))
      return Status.STATUS_INVALID_CREDIT_CARD;
    else if(status.equals("STATUS_CANCELLED_NOCREDIT"))
      return Status.STATUS_CANCELLED_NOCREDIT;
    else if(status.equals("STATUS_CANCELLED_NOINV"))
      return Status.STATUS_CANCELLED_NOINV;
    else if(status.equals("STATUS_INPROCESS"))
      return Status.STATUS_INPROCESS;
    else if(status.equals("STATUS_PROCESSED"))
      return Status.STATUS_PROCESSED;
    else if(status.equals("STATUS_SHIPPED"))
      return Status.STATUS_SHIPPED;
    else
      return Status.STATUS_INVALID;
  }
}
