#!/bin/sh
#
#
# generateldif.sh
#
# Copyright (c) 2001, 2002, Oracle Corporation.  All rights reserved.  
#
#    NAME
#      generateldif.sh - <one-line expansion of the name>
#
#    DESCRIPTION
#    This script is used for generating JAZN ldif files from JAZN 
#    template (*.sbs) files given JAZN meta (*.lst) files.
#    This scripts takes the mandatory parameter OracleContextDN
#    specified by "-b" option.  It then invokes generateldif.pl perl 
#    script to generate the ldif files.
#
#    NOTES
#    Assumption: JAZN's meta files (*.lst) and tempalte files (*.sbs)
#    and generateldif.pl script are available in the same directory 
#    where generateldif.sh is run.
######################################################################
while test $# -gt 0
do
  case $1 in
    -b) shift; ORACLE_CONTEXT="$1";;
    -help) echo "Usage: generateldif.sh [-b OracleContextDN]"; exit 1;;
   esac
  shift
done

if [ -z "${ORACLE_CONTEXT}" ]; then 
    echo "Usage: generateldif.sh [-b OracleContextDN]"
    exit 1 
fi
export ORACLE_CONTEXT

PERLLIB=%ORACLE_HOME%/perl/lib/5.6.1
export PERLLIB

#set install directory where the lst files are expected
INSTALLDIR=%ORACLE_HOME%/j2ee/home/jazn/install
export INSTALLDIR

$INSTALLDIR/generateldif.pl -b $ORACLE_CONTEXT -f $INSTALLDIR/oidSchemaCreateJAZN.lst 

$INSTALLDIR/generateldif.pl -b $ORACLE_CONTEXT -f $INSTALLDIR/oidContextCreateJAZN.lst

$INSTALLDIR/generateldif.pl -b $ORACLE_CONTEXT -f $INSTALLDIR/oidDemoDataCreateJAZN.lst

$INSTALLDIR/generateldif.pl -b $ORACLE_CONTEXT -f $INSTALLDIR/oidSchemaCreateJAZNLM.lst