@echo off
setlocal

rem
rem Check Argument list
rem

if not "%1" == "-h" goto Usage
if not "%3" == "-p" goto Usage
if not "%5" == "-D" goto Usage
if not "%7" == "-w" goto Usage
if "%8" == "" goto Usage

rem
rem Set Environment Variables from argument list
rem

set LDAP_HOST=%2
set LDAP_PORT=%4
set BIND_DN=%6
set BIND_PASSWD=%8
if "%9" == "" (
   set LOAD=Demo
) else (
   set LOAD=%9
)

rem
rem Set Other Environment Variables
rem

set INSTALLDIR=%ORACLE_HOME%\j2ee\home\jazn\install

if "%LOAD%"=="Demo" (
   "%ORACLE_HOME%\bin\ldapmodify" -c -a -p %LDAP_PORT% -h %LDAP_HOST% -D %BIND_DN% -w %BIND_PASSWD% -f %INSTALLDIR%\oidDemoDataCreateJAZN.ldif >> %INSTALLDIR%\postinstall.log
   echo "*** Done loading demo data! please check %INSTALLDIR%\postinstall.log for results ***"
   goto :done
)

if "%LOAD%" == "LoginModule" (
   "%ORACLE_HOME%\bin\ldapmodify" -c -a -p %LDAP_PORT% -h %LDAP_HOST% -D %BIND_DN% -w %BIND_PASSWD% -f %INSTALLDIR%\oidDemoDataCreateJAZNLM.ldif >> %INSTALLDIR%\postinstall.log
   echo "*** Done loading login module! please check %INSTALLDIR%\postinstall.log for results ***"
   goto :done
)

if "%LOAD%" == "All" (
   "%ORACLE_HOME%\bin\ldapmodify" -c -a -p %LDAP_PORT% -h %LDAP_HOST% -D %BIND_DN% -w %BIND_PASSWD% -f %INSTALLDIR%\oidSchemaCreateJAZN.ldif >> %INSTALLDIR%\postinstall.log
   "%ORACLE_HOME%\bin\ldapmodify" -c -a -p %LDAP_PORT% -h %LDAP_HOST% -D %BIND_DN% -w %BIND_PASSWD% -f %INSTALLDIR%\oidContextCreateJAZN.ldif >> %INSTALLDIR%\postinstall.log
   "%ORACLE_HOME%\bin\ldapmodify" -c -a -p %LDAP_PORT% -h %LDAP_HOST% -D %BIND_DN% -w %BIND_PASSWD% -f %INSTALLDIR%\oidDemoDataCreateJAZN.ldif >> %INSTALLDIR%\postinstall.log
   echo "*** Done loading JAZN base schema and demo data! please check %INSTALLDIR%\postinstall.log"for results ***
   goto :done    
)

goto :done

rem 
rem Usage Prompt
rem

:Usage
echo "Usage: postinstall.bat [-h ldaphost] [-p ldapport] [-D binddn] [-w password] [<Demo | All>]"

:done

endlocal
